#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <IE.au3> 

#Region ### START Koda GUI section ### Form=C:\au3scripts\tbf\Form2.kxf
$Form2 = GUICreate("TB2.5 Import Utility v2.0", 416, 213, 205, 129)
$GroupBox1 = GUICtrlCreateGroup("", 8, 1, 377, 169)
$Label1 = GUICtrlCreateLabel("Final year of import", 16, 16, 92, 15)
$selYear = GUICtrlCreateCombo("", 16, 32, 119, 25)
buildYearSelect($selYear)
$txtSource = GUICtrlCreateInput(@MyDocumentsDir & "\" & "Out of the Park Developments\Title Bout Championship Boxing 2.5\Exchange\", 16, 77, 273, 21)

$Label2 = GUICtrlCreateLabel("Location of TBDX files to modify", 16, 61, 155, 15)
$Label3 = GUICtrlCreateLabel("Location to save modified TBDX files", 17, 106, 178, 15)
$txtDest = GUICtrlCreateInput("", 16, 121, 273, 21)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$btnStart = GUICtrlCreateButton("Start", 14, 172, 75, 25, 0)
$btnExit = GUICtrlCreateButton("Exit", 93, 172, 75, 25, 0)
$btnHelp = GUICtrlCreateButton("Help", 173, 172, 75, 25, 0)
$btnBrowseSource = GUICtrlCreateButton("Browse", 297, 74, 75, 25, 0)
$btnBrowseDest = GUICtrlCreateButton("Browse", 297, 118, 75, 25, 0)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $btnExit
			Exit
			
		Case $btnBrowseSource
			$srcDir = FileSelectFolder("Choose directory containing exported tbdx files.","",7, @MyDocumentsDir & "\" & "Out of the Park Developments\Title Bout Championship Boxing 2.5\Exchange\" )
			If($srcDir<>'') Then
				If(StringRight($srcDir,1) <> '\') Then
					$srcDir = $srcDir & "\"
				EndIf
				
				GuiCtrlSetData($txtSource,$srcDir)
			EndIf
		Case $btnBrowseDest
			$destDir = FileSelectFolder("Choose directory containing exported tbdx files.","",7, @MyDocumentsDir & "\" & "Out of the Park Developments\Title Bout Championship Boxing 2.5\Exchange\" )
			If($destDir<>'') Then
				If(StringRight($destDir,1) <> '\') Then
					$destDir = $destDir & "\"
				EndIf
				
				GuiCtrlSetData($txtDest,$destDir)
			EndIf
		Case $btnStart
			$useCurrentRecord = FALSE
			$endDate = '2000'
			$foundProblems = FALSE
			If(GuiCtrlRead($selYear)='') Then
				GUICtrlSetColor($Label1, 0xff0000)
				$foundProblems=TRUE
			Else
				GUICtrlSetColor($Label1, 0x000000)
				If(GuiCtrlRead($selYear)="Use Current Record") Then
					$useCurrentRecord=True
				Else
					$endDate=GuiCtrlRead($selYear)
				EndIf
				
			EndIf
			
			If(GuiCtrlRead($txtSource)='') Then
				GUICtrlSetColor($Label2, 0xff0000)
				$foundProblems=TRUE
			Else
				$srcDir = GUICtrlRead($txtSource)
				If(StringRight($srcDir,1) <> '\') Then
					$srcDir = $srcDir & "\"
				EndIf
				GUICtrlSetColor($Label2, 0x000000)
			EndIf
			
			If(GuiCtrlRead($txtDest)='') Then
				GUICtrlSetColor($Label3, 0xff0000)
				$foundProblems=TRUE
			Else
				$destDir = GuiCtrlRead($txtDest)
				
				If(StringRight($destDir,1) <> '\') Then
					$destDir = $destDir & "\"
				EndIf
				GUICtrlSetColor($Label3, 0x000000)
			EndIf
			
			If($foundProblems) Then
				MsgBox(0,"Errors detected","Please correct the items listed in red.")
			Else
				$tempDir = $destDir & "temp\"
				If(Not FileExists($tempDir)) Then
					DirCreate($tempDir)
				EndIf
				
				$oIE = _IECreate("about:blank",0,0)

				$count = getCount($srcDir)
				If($count <> -1) Then
					;MsgBox(0,"Count",$count)
				EndIf


				$search = FileFindFirstFile($srcDir & "*.tbdx3")
				If($search = -1) Then
					MsgBox(0,"Error","No files found(search)")
					Exit
				EndIf

				$written=0
				GuiSetState(@SW_HIDE)

				ProgressOn("TB2.5 Record Import","Import Progress","0 Percent")
				
				While 1
					$srcFile = FileFindNextFile($search)
					If(@error) Then
						ExitLoop
					EndIf
					$destFile = StringReplace($srcFile,".tbdx3","_mod.tbdx3")
					$brID = getBoxRecID($srcDir & $srcFile)
					;MsgBox(0,"BR ID",$brID)
					dim $records[4]
					if($brID<>'') Then
						If($useCurrentRecord) Then
							getRecord($oIE,$brID,$records,$tempDir)
							getCurrentRecord($brID,$records,$tempDir)
							$written = $written + 1
							writeRecords($srcDir & $srcFile,$destDir & $destFile,$records,$written,$count)
						Else
							getRecord($oIE,$brID,$records,$tempDir)
							getHistoricalRecord($brID,$tempDir,$endDate,$records)
							$written = $written + 1
							writeRecords($srcDir & $srcFile,$destDir & $destFile,$records,$written,$count)
						EndIf
		
		
					EndIf
				WEnd
				ProgressOff()
				FileClose($search)
				_IEQuit($oIE)
				$complete = MsgBox(4,"Import Complete","Record modification complete." & @CRLF & "Modified files saved to " & $destDir & "." & @CRLF & "Do you want to perform another import?")
				;MsgBox(0,"Complete","Record modification complete." & @CRLF & "Modified files saved to " & $destDir)
				If($complete=6) Then
					GuiSetState(@SW_SHOW)
				Else
					Exit
				EndIf
				
			EndIf
			
			
			
	EndSwitch
WEnd

Func buildYearSelect($selYear)
	$out = "Use Current Record|"
	
	For $i = @YEAR - 1 to 1900 Step -1
		$out = $out & $i & "|"
	Next
	GUICtrlSetData($selYear,$out)
EndFunc

Func getCount($srcDir)
	$search = FileFindFirstFile($srcDir & "*.tbdx3")
	If($search = -1) Then
		return -1
	EndIf
	$count = 0
	While 1
		$srcFile = FileFindNextFile($search)
		if(@error) Then
			ExitLoop
		EndIf
		$count = $count + 1
	WEnd
	FileClose($search)
	return $count
	
EndFunc

Func getBoxRecID($fileToRead)
	$file = FileOpen($fileToRead,16)
	$line = FileRead($file,190)
	FileClose($file)

	$id = StringRight($line,8)

	$array = StringSplit($id,"")

	dim $byte[4]
	$byte0 = $array[1] & $array[2]
	$byte1 = $array[3] & $array[4]
	$byte2 = $array[5] & $array[6]
	$byte3 = $array[7] & $array[8]
	
	$string = Hex("0x" & $byte3 & $byte2 & $byte1 & $byte0)
	$newID = Dec($string)
	
	return $newID
EndFunc

Func getRecord($oIE,$brID,ByRef $records,$tempDir)
	$url = "http://www.boxrec.com/prt.php?human_id=" & $brID &"&cat=boxer"
	;$oIE = _IECreate($url)
	_IENavigate($oIE,$url)
	$bodyText = _IEBodyReadText($oIE)
	$writeTest = FileWriteLine($tempDir & $brID & ".txt",$bodyText)
EndFunc

Func getCurrentRecord($brID,ByRef $records,$tempDir)
	;MsgBox(0,"",$tempDir & $brID)
	;
	;MsgBox(0,"",FileReadLine("C:\au3scripts\tbf\temp\" & $newID & ".txt",-1))
	$recArray = StringSplit(FileReadLine($tempDir & $brID & ".txt",-1)," ")
	;MsgBox(0,"",$recArray[0])
	$wins = $recArray[2]
	$kos = StringReplace($recArray[4],')','')
	$losses = $recArray[7]
	$draws = $recArray[10]

	$records[0]=$wins
	$records[1]=$kos
	$records[2]=$losses
	$records[3]=$draws
	
EndFunc

Func getHistoricalRecord($brID,$tempDir,$endDate,ByRef $records)
	$file = FileOpen($tempDir & $brID & ".txt",0)
	$wins = 0
	$losses = 0
	$draws = 0
	$kos = 0
	
	While 1
		$line = FileReadLine($file)
		If(@error = -1) Then
			ExitLoop
		EndIf
		If(StringLeft($line,4)+0 > 0 And StringLeft($line,4)+0 <= $endDate ) Then
			;MsgBox(0,"$line",StringRight($line,9))
			$array = StringSplit(StringStripWS(StringRight($line,9),6),' ')
			;1 = outcome, 2 = type, 3 = round
			If($array[0] <> 3) Then
				MsgBox(0,"Error","Array not expected size " & $line)
				Exit
			EndIf
			
			Switch $array[1]
				Case "W"
					$wins = $wins + 1
				Case "L"
					$losses = $losses + 1
				Case "D"
					$draws = $draws + 1
				Case "C"
					;this is a no contest, not counted in records except for fight totals
				Case Else
					MsgBox(0,"Error","Unexpected result " & $line & " " & $array[1])
			EndSwitch
			
			If(($array[2] = "KO" OR $array[2] = "TKO" OR $array[2] = "RTD") AND $array[1]="W") Then
				$kos = $kos + 1
			EndIf
			
			
				
		EndIf
		
	WEnd
	$records[0] = $wins
	$records[1] = $kos
	$records[2] = $losses
	$records[3] = $draws
	
	FileClose($file)
EndFunc

Func writeRecords($srcFile,$destFile,$records,$written,$count)
	ProgressSet($written/$count*100,"Record " & $written & " of " & $count)
	$file = FileOpen($srcFile,16)
	$newFile = FileOpen($destFile,18)
	
	$line = FileRead($file)
	FileClose($file)
	$string = ''
	For $i=1 to StringLen($line)
		$byte = StringRight(StringLeft($line,$i * 2),2)
		;Msgbox(0,"",$byte)
	
		Switch $i
		Case 310
			;wins
			;MsgBox(0,"",$byte & " to " & $records[0])
			$string = $string & StringRight(Hex($records[0]),2)
		Case 314
			;losses
			;MsgBox(0,"",$byte & " to " & $records[2])
			$string = $string & StringRight(Hex($records[2]),2)
		Case 318
			;draws
			;MsgBox(0,"",$byte & " to " & $records[3])
			$string = $string & StringRight(Hex($records[3]),2)
		Case 322
			;win by knockout
			;MsgBox(0,"",$byte & " to " & $records[1])
			$string = $string & StringRight(Hex($records[1]),2)
		Case Else
			$string = $string & $byte
		EndSwitch
		;MsgBox(0,"",StringToBinary($byte))
	
	Next
	FileWrite($newFile,$string)
	
	FileClose($newFile)
EndFunc



